
# Copyright 1996 Veritas Software 

# an object that manages a set of clients to call

class notify:
	# maintain a list of objects, methodname and call
	def __init__(self):
		self.notifylist=[]

	def register(self, *arglist):
		self.notifylist.append(arglist)

	def unregister(self, *old):
		if old in self.notifylist:
			self.notifylist.remove(old)

	def callclients(self):
		# don't call if client isn't on list by time we get to it.
		currentlist=self.notifylist[:]
		for client in currentlist:
			if client in self.notifylist:
				apply(client[0], client[1:])


def test():
 	def testcb():
		print 'testcb'
 
	def testcb2(arg1):
		print 'testcb2 with one arg:', arg1

	class testfoo:
		def amethod(self):
			print 'a no-arg method'
		def complexmethod(self, arg1, *arg2):
			print 'complex method with arg 1=', arg1,
			print ',arg2 is', arg2

		def registerself(self, notifier):
			notifier.register(self.amethod)
			notifier.register(self.complexmethod, 1, 2)

	print 'Running test...'

	z=testfoo()
	b=notify()
 
	b.register(testcb)
	b.register(testcb2, 'a')
	b.callclients()
	b.unregister(testcb)
	b.unregister(testcb2, 'a')

	b.register(z.amethod)
	b.register(z.complexmethod, 1, 2)
	b.callclients()
	b.unregister(z.amethod)
	b.unregister(z.complexmethod, 1, 2)

	z.registerself(b)
	b.callclients()

	print 'Test complete.'

if __name__ == '__main__':
	test()

